# DO NOT MODIFY -- This file is generated by type_spec
# flake8: noqa: F821
# ruff: noqa: E402 Q003
# fmt: off
# isort: skip_file
from __future__ import annotations
import typing  # noqa: F401
import datetime  # noqa: F401
from decimal import Decimal  # noqa: F401
from pkgs.strenum_compat import StrEnum
import dataclasses
from pkgs.serialization import serial_class
from pkgs.serialization import serial_union_annotation
from ... import identifier_t
from ... import recipe_inputs_t
from ... import recipe_workflow_steps_t

__all__: list[str] = [
    "AnnotationEdit",
    "Arguments",
    "Data",
    "ENDPOINT_METHOD",
    "ENDPOINT_PATH",
    "RecipeInputEdit",
    "RecipeInputEditAddInput",
    "RecipeInputEditBase",
    "RecipeInputEditChangeBasisViewed",
    "RecipeInputEditClearInputs",
    "RecipeInputEditInputBase",
    "RecipeInputEditSetLot",
    "RecipeInputEditType",
    "RecipeInputEditUpdateAnnotations",
    "RecipeInputEditUpsertInput",
]

ENDPOINT_METHOD = "POST"
ENDPOINT_PATH = "api/external/recipes/edit_recipe_inputs"


# DO NOT MODIFY -- This file is generated by type_spec
class RecipeInputEditType(StrEnum):
    CLEAR_INPUTS = "clear_inputs"
    UPSERT_INPUT = "upsert_input"
    ADD_INPUT = "add_input"
    UPDATE_ANNOTATIONS = "update_annotations"
    SET_LOT = "set_lot"
    CHANGE_BASIS = "change_basis"


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditBase:
    type: RecipeInputEditType


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditClearInputs(RecipeInputEditBase):
    type: typing.Literal[RecipeInputEditType.CLEAR_INPUTS] = RecipeInputEditType.CLEAR_INPUTS


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    to_string_values={"value_numeric"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditInputBase(RecipeInputEditBase):
    ingredient_key: identifier_t.IdentifierKey
    quantity_basis: recipe_inputs_t.QuantityBasis = recipe_inputs_t.QuantityBasis.MASS
    input_value_type: recipe_inputs_t.InputValueType = recipe_inputs_t.InputValueType.VALUE
    value_numeric: typing.Optional[Decimal] = None
    value_str: typing.Optional[str] = None
    calculation_key: typing.Optional[identifier_t.IdentifierKey] = None


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditChangeBasisViewed(RecipeInputEditInputBase):
    type: typing.Literal[RecipeInputEditType.CHANGE_BASIS] = RecipeInputEditType.CHANGE_BASIS


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditUpsertInput(RecipeInputEditInputBase):
    type: typing.Literal[RecipeInputEditType.UPSERT_INPUT] = RecipeInputEditType.UPSERT_INPUT
    clear_first: bool


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditAddInput(RecipeInputEditInputBase):
    type: typing.Literal[RecipeInputEditType.ADD_INPUT] = RecipeInputEditType.ADD_INPUT


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditSetLot(RecipeInputEditBase):
    type: typing.Literal[RecipeInputEditType.SET_LOT] = RecipeInputEditType.SET_LOT
    ingredient_key: identifier_t.IdentifierKey
    ingredient_lot_recipe_key: identifier_t.IdentifierKey


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    to_string_values={"lower_value", "upper_value"},
)
@dataclasses.dataclass(kw_only=True)
class AnnotationEdit:
    annotation_type_key: identifier_t.IdentifierKey
    lower_value: typing.Optional[Decimal] = None
    upper_value: typing.Optional[Decimal] = None


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class RecipeInputEditUpdateAnnotations(RecipeInputEditInputBase):
    type: typing.Literal[RecipeInputEditType.UPDATE_ANNOTATIONS] = RecipeInputEditType.UPDATE_ANNOTATIONS
    ingredient_key: identifier_t.IdentifierKey
    clear_first: bool
    annotations: list[AnnotationEdit]


# DO NOT MODIFY -- This file is generated by type_spec
RecipeInputEdit = typing.Annotated[
    typing.Union[RecipeInputEditClearInputs, RecipeInputEditUpsertInput, RecipeInputEditAddInput, RecipeInputEditUpdateAnnotations, RecipeInputEditSetLot, RecipeInputEditChangeBasisViewed],
    serial_union_annotation(
        discriminator="type",
        discriminator_map={
            "clear_inputs": RecipeInputEditClearInputs,
            "upsert_input": RecipeInputEditUpsertInput,
            "add_input": RecipeInputEditAddInput,
            "update_annotations": RecipeInputEditUpdateAnnotations,
            "set_lot": RecipeInputEditSetLot,
            "change_basis": RecipeInputEditChangeBasisViewed,
        },
    ),
]


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class Arguments:
    recipe_key: identifier_t.IdentifierKey
    recipe_workflow_step_identifier: recipe_workflow_steps_t.RecipeWorkflowStepIdentifier
    edits: list[RecipeInputEdit]


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class Data:
    pass
# DO NOT MODIFY -- This file is generated by type_spec
